-- exw2prj.ex
-- Copyright (c) 2001-2002 Martin Stachon
--
-- converts an euphoria .exw file to Judtih's IDE project .prj
-- see doc\ directory for more info

include misc.e

global integer DEBUG
DEBUG = 0 -- for debugging purposes

global integer log_fn
if DEBUG then
	log_fn = open("log.txt", "w")
end if

global constant LF = '\n',
AppName = "exw2prj 1.1 final (IDE 0.12)"

global integer out_fn

global sequence input_file_lines

include ox_lex.e    -- the lexer
include exw_tokens.e
include exw_parser.e
include ide_prj.e

oxShowParseError = 0 
-- change to 1 if you want to see all ox warnings
-- LOTS of warnings !

procedure read_input_file(integer fn)
	object line
	input_file_lines = {}
	while 1 do
		line = gets(fn)
		if atom(line) then
			exit          -- EOF
		else
			input_file_lines &= {line}
		end if
	end while
end procedure

procedure main(sequence cmd)
	sequence in_file, out_file
	integer in_fn
	
	puts(1, AppName & " by Martin Stachon\n")

	if length(cmd) < 3 then
		cmd &= {prompt_string("Input file ?  ")}
	end if
	if length(cmd) < 4 then
		cmd &= {prompt_string("Output file ? ")}
	end if

	in_file  = cmd[3]
	out_file = cmd[4]
	out_fn = open(out_file, "w")
	if out_fn = -1 then
		puts(2, "Error: Cannot open output file !\n")
		return
	end if
	in_fn = open(in_file, "r")
	if in_fn = -1 then
		puts(2, "Error: Cannot open input file !\n")
		return
	end if
	puts(1, "Initializing Ox...     ")
	oxInit()
	puts(1, "Done.\n")
	puts(1, "Loading input file...  ")
	oxLoadFile( in_file )
	puts(1, "Done.\n" )
	puts(1, "Analysing input file...\n")
	parse_file()
	puts(1, "Done.\n")	
	read_input_file(in_fn)
	close(in_fn)
	puts(1, "Writing output file... \n")
	write_project()
	puts(1, "Finished.\n")
	oxUnloadFile()
	close(out_fn)
	if DEBUG then
		close(log_fn)
	end if
end procedure

main(command_line()) 

include get.e

if platform() = WIN32 then
	puts(1, "Press any key...")
	if wait_key() then
	end if
end if
