-- exw_tokens.e

-- types of tokens
global constant
	Proc            = 1, -- procedure start
	EndProc         = 2, -- end of procedure
	RegisterEvent   = 3, -- onClick[id] = routine_id("..")
	ControlCreation = 4, -- id = create(..)
	Junk            = 5, -- we're going not to put this into PRJ
	WinMain         = 6,
	Nothing         = 0  -- all other code

-- scope of a control
global constant
	LOCAL  = 1,
	GLOBAL = 2	

-- events trapped
global constant events = 
{
	"onChange",
	"onClick",
	"onClose",
	"onDestroy",
	"onDragAndDrop",
	"onEvent",
	"onGotFocus",
	"onKeyDown",
	"onKeyPress",
	"onKeyUp",
	"onLostFocus",
	"onMouse",
	"onOpen",
	"onPaint",
	"onScroll",
	"onResize",
	"onRightClick",
	"onTimer",
	"onActivate"
}

-- styles of flags in create()
global constant
	NoStyle       = 1,   -- nothing or single constant
	SeqStyle      = 2,   -- {...}
	OrAllStyle    = 3    -- or_all({...})

-- types of captions :
global constant
	CAPTION_SINGLE = 1,
	CAPTION_SEQ    = 2

global constant
	Default        = #80000000 -- Default x/y, taken from win32lib

-- reported tokens
global sequence
	created_controls,
	registered_events,
	ignored,
	routines,
	winmain

created_controls  = {}
registered_events = {}
ignored           = {}
routines          = {}
winmain           = {}


-- indexes of the sequences above
global constant
	-- created_controls
	CONTROL_SCOPE   = 1,
	CONTROL_NAME    = 2,
	CONTROL_CLASS   = 3,
	CONTROL_CAPTION = 4,
		CAPTION_STYLE = 1,
		CAPTION_VALUE = 2,
	CONTROL_PARENT  = 5,
	CONTROL_PARENTID = 12,
	CONTROL_X       = 6,
	CONTROL_Y       = 7,
	CONTROL_CX      = 8,
	CONTROL_CY      = 9,
	CONTROL_FLAGS   = 10,
		FLAGS_STYLE = 1,
		FLAGS_VALUE = 2,
	CONTROL_EXFLAGS = 11,
	--	FLAGS_STYLE = 1,
	--	FLAGS_VALUE = 2,
		

	-- registered_events
	EVENT_NAME         = 5,
	EVENT_FORID        = 6,
	EVENT_ROUTINE      = 7,

	-- routines
	ROUTINE_NAME       = 1,
	ROUTINE_START      = 2,
	ROUTINE_END        = 3,
	ROUTINE_USED       = 4,
	
	-- winmain
	WINMAIN_NAME       = 1,
	WINMAIN_TYPE       = 2	
		
global procedure parseWarning(sequence s)
	-- prints a warning plus current line and text being parsed
	printf(1, "Parse warning on line %d: %s"&LF, {oxLineNum, s})
	puts(1, '\t' & oxString)
end procedure


-- helpers for the parser
integer
	this_token_start,
	this_token_start_line

global procedure store_token_start()
-- stores position of the previous token

	integer last
	
	last = oxTokenIndex -1
	if last = 0 then
		this_token_start = oxLastTokenStart
	end if

	this_token_start      = oxTokensStarts[last] 
	this_token_start_line = oxLineNum
end procedure

global function get_token_range()
	integer last

	last = oxTokenIndex -1
	if last = 0 then
			-- POSSIBLE PROBLEM HERE with oxLastTokenStart
			return { this_token_start, this_token_start_line, 
			oxLastTokenStart, oxLastLineNum }
	end if

	return { this_token_start, this_token_start_line, 
	oxTokensStarts[last]+length(oxTokens[last])-1, oxLineNum }
end function
	